# psim を利用するためのおまじない -- ここから
import winreg, sys, os
reg = winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE, "SOFTWARE\\Wow6432Node\\Mathematical Systems Inc.\\S-Quattro Simulation System\\INFO")
rootdir = winreg.QueryValueEx(reg, "ROOTDIR")[0]
os.environ["PATH"] = rootdir + ";" + os.environ["PATH"]
sys.path.insert(0, os.path.join(rootdir, "lib3"))
# psim を利用するためのおまじない -- ここまで

from psim import *
import matplotlib.pyplot as plt
import matplotlib
import pandas as pd
import pdb

initialize()

S = Value(999, name = "S", monitor = True) # 感受性者数
I = Value(1, name = "I", monitor = True) # 感染者数
R = Value(0, name = "R", monitor = True) # 回復/隔離者数

beta = 0.001 # 単位時間あたりの感染率
gamma = 0.2 # 単位時間あたりの回復や隔離による除去率

def proc():
    yield continuous([S, I, R],
                     [],
                     lambda T, S, I, R: (
                         -beta * S * I,
                         beta * S * I - gamma * I,
                         gamma * I))

activate(proc)()

start(until = 30)

plt.plot(S.monitor.time().toList(), S.monitor.toList()[0], label = "S")
plt.plot(I.monitor.time().toList(), I.monitor.toList()[0], label = "I")
plt.plot(R.monitor.time().toList(), R.monitor.toList()[0], label = "R")
plt.legend()
#plt.savefig("psim7-sir.png")
plt.show()

