# psim を利用するためのおまじない -- ここから
import winreg, sys, os
reg = winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE, "SOFTWARE\\Wow6432Node\\Mathematical Systems Inc.\\S-Quattro Simulation System\\INFO")
rootdir = winreg.QueryValueEx(reg, "ROOTDIR")[0]
os.environ["PATH"] = rootdir + ";" + os.environ["PATH"]
sys.path.insert(0, os.path.join(rootdir, "lib3"))
# psim を利用するためのおまじない -- ここまで

from psim import *
import matplotlib.pyplot as plt
import matplotlib
import pandas as pd
import pdb

initialize()

beta = 0.001 # 単位時間あたりの感染率
gamma = 0.2 # 単位時間あたりの回復や隔離による除去率

class Agent:
    def __init__(self, state):
        # 状態は "S"/"I"/"R"
        self.state = state
    def step(self, I):
        # I は、感染者数
        if self.state == "S":
            # 感受性者は、beta * I の確率で感染する
            if np.random.uniform() <= beta * I:
                self.state = "I"
        elif self.state == "I":
            # 感染者は、gamma の確率で回復もしくは隔離
            if np.random.uniform() <= gamma:
                self.state = "R"

# エージェントの初期化
agents = []

for i in range(999):
    agents.append(Agent("S"))
for i in range(1):
    agents.append(Agent("I"))
for i in range(0):
    agents.append(Agent("R"))

hist = []

def proc():
    while True:
        I = len([a for a in agents if a.state == "I"])
        # 全エージェントを状態遷移させる
        for i in range(len(agents)):
            agents[i].step(I)
        # エージェントの状態をカウントする
        S = 0
        I = 0
        R = 0
        for a in agents:
            if a.state == "S":
                S += 1
            elif a.state == "I":
                I += 1
            elif a.state == "R":
                R += 1
        # 記録
        hist.append([S, I, R])
        # 時間発展
        yield pause(1)

activate(proc)()

start(until = 30)

hist = np.array(hist)
plt.plot(hist[:, 0], label = "S")
plt.plot(hist[:, 1], label = "I")
plt.plot(hist[:, 2], label = "R")
plt.legend()
plt.show()
#plt.savefig("psim8-sir.png")

